<script setup lang="ts">
import { ref, onMounted } from 'vue';

import ImageFlipper from '@/components/ImageFlipper.vue';

const props = withDefaults(
  defineProps<{
    people: string[];
    timers?: number[];
    initialFlippedStates?: boolean[];
  }>(),
  { timers: () => [4100, 3600, 2250, 4725], count: 4, initialFlippedStates: () => [false, true, false, false] }
);

const activePeople = ref(props.people.slice(0, props.initialFlippedStates.length));
const inactivePeople = ref(props.people.slice(props.initialFlippedStates.length));
const isFlippedStates = ref(props.initialFlippedStates);
const intervals: ReturnType<typeof setInterval>[] = [];

const updateActiveSpot = (index: number) => {
  const currentlyActivePerson = activePeople.value[index];
  inactivePeople.value.push(currentlyActivePerson);
  activePeople.value[index] = inactivePeople.value.shift()!;
};

onMounted(() => {
  props.initialFlippedStates.forEach((flippedState, i) => {
    intervals[i] = setInterval(() => {
      if (isFlippedStates.value[i]) {
        setTimeout(() => updateActiveSpot(i), 1500);
      }
      isFlippedStates.value[i] = !isFlippedStates.value[i];
    }, props.timers[i]);
  });
});
</script>

<template>
  <div class="flex flex-row grow justify-center">
    <div class="grid grid-cols-2 sm:grid-cols-4 gap-3">
      <ImageFlipper v-for="(person, i) in activePeople" :imageUrl="`/${person}.jpg`" :key="person" :delay="timers[i]" :index="i" @update="updateActiveSpot" :isActive="isFlippedStates[i]" />
    </div>
  </div>
</template>
